(function ($) {

  Drupal.behaviors.payRealexRedirect = {
    attach: function(context, settings) {
      window.setTimeout(function() {
        $('#pay-realex-redirect-form').submit();
      }, 800);

      if (window.addEventListener) {
        window.addEventListener("message", receiveMessage, false);
      } else {
        window.attachEvent('message', receiveMessage);
      }
    }

  };

  function getHostnameFromUrl(url) {
    var parser = document.createElement('a');
    parser.href = url;
    return parser.hostname;
  }

  function receiveMessage(event) {
    var merchantUrl = '/pay-realex/realex-redirect-response';
    try {
      var hppUrl = Drupal.settings.pay_realex.gateway_url;
    }
    catch(e) {
      // Just in case for whatever reason Drupal.settings is being stupid,
      // set a default.
      var hppUrl = 'https://hpp.realexpayments.com/pay';
    }

    //Check the origin of the response comes from HPP
    if (getHostnameFromUrl(event.origin) === getHostnameFromUrl(hppUrl)) {

      // check for iframe resize values
      if (event.data && JSON.parse(event.data).iframe) {
        var iframeWidth = JSON.parse(event.data).iframe.width;
        var iframeHeight = JSON.parse(event.data).iframe.height;

        var iFrame = document.getElementById("pay_realex_redirect");
        iFrame.setAttribute("width", iframeWidth);
        iFrame.setAttribute("height", iframeHeight);
        iFrame.style.backgroundColor="#ffffff";

        iFrame.style.marginLeft = (parseInt(iframeWidth.replace("px", ""), 10)/2 * -1 ) + "px";

      } else {
        var response = event.data;

        //Create a form and submit the hpp response to the merchant's response url
        var form = document.createElement("form");
        form.setAttribute("method", "POST");
        form.setAttribute("action", merchantUrl);

        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", "hppResponse");
        hiddenField.setAttribute("value", response);

        form.appendChild(hiddenField);

        document.body.appendChild(form);

        form.submit();
      }
    }
  }

})(jQuery);
